#include "bagb_encoder.hpp"

#include <set>
#include <sstream>
#include <iostream>

void bagb_encoder::set_elements(const vocab&v)
{

  for(int i=0;i<v.words().size();++i)
  {
    int j=0;
    for(;j<v.words()[i].length();++j)
    {
      letters_.insert(v.words()[i][j]);
    }
    if(j>len_) len_=j;
  }
  int ii=0,jj=0;
  element_names_.push_back("bias");
  for(auto i=letters_.begin();i!=letters_.end();++i,++ii)
  {
    letnum_[*i]=ii;
    for(int j=0;j<len_;++j)
    {
      std::stringstream ss;
      ss<<*i<<j;
      element_names_.push_back(ss.str());
    }
    for(auto l=letters_.begin();l!=letters_.end();++l,++jj)
    {
      std::string s="  ";
      s[0]=*i;s[1]=*l;
      bigrams_.insert(s);
      bigrnum_[s]=jj;
    }    
  }
  for(auto i=bigrams_.begin();i!=bigrams_.end();++i)
  {
    for(int j=0;j<(len_*(len_-1))/2;++j)
    {
      std::stringstream ss;
      ss<<*i<<j;
      element_names_.push_back(ss.str());
    }
  }
}

std::vector<pattern> bagb_encoder::encode_strings(const std::vector<std::string>&vs)const
{
  std::vector<pattern> vp(vs.size());
  int j=0;
  for(auto i=vs.begin();i!=vs.end();++i,++j)
  {
    std::vector<std::string> bigrams;
    vp[j].push_back(0);
    for(int l=0;l<i->length();++l)
    {
      int p=0;
      for(int z=0;z<l;++z)
      {
        if((*i)[l]==(*i)[z]) ++p;
        std::string b="  ";
        b[0]=(*i)[z]; b[1]=(*i)[l];
        bigrams.push_back(b);
      }
      auto ln=letnum_.find((*i)[l]);
      vp[j].push_back(1+ln->second*len_+p);
    }
    for(auto l=bigrams.begin();l!=bigrams.end();++l)
    {
      int p=0;
      for(auto m=bigrams.begin();m!=l;++m)
      {
        if(*m==*l) ++p;
      }
      auto bn=bigrnum_.find(*l);
      vp[j].push_back(1+(letters_.size()+bn->second)*len_+p);
    }
    
  }
  return vp;
}

