#ifndef RWODS_SLOPPY_ENCODER_HPP
#define RWODS_SLOPPY_ENCODER_HPP

#include <map>
#include <set>

#include "rpattern.hpp"
#include "encoder.hpp"

struct sloppy_encoder:encoder
{
  sloppy_encoder(double sigma=1.):len_(0),sigma_(sigma){}

  void set_elements(const vocab&);
  std::vector<pattern> encode_strings(const std::vector<std::string>&)const;

  private:
  
  std::set<char> letters_;
  std::map<char,int> letnum_;
  int len_;
  double sigma_;
};

#endif
